summaryrefslogtreecommitdiff
path: root/tests/tail-2/assert
diff options
context:
space:
mode:
authorJim Meyering <jim@meyering.net>1999-11-22 08:54:09 +0000
committerJim Meyering <jim@meyering.net>1999-11-22 08:54:09 +0000
commitf22a30f1e537f8442b58c453c075842de7b9d961 (patch)
tree95f6ef25e5183246ab6af6bc880f03a4d319c02d /tests/tail-2/assert
parent4917680b1afb71476f4b6fe356917e2a30f14069 (diff)
downloadcoreutils-f22a30f1e537f8442b58c453c075842de7b9d961.tar.xz
*** empty log message ***
Diffstat (limited to 'tests/tail-2/assert')
-rwxr-xr-xtests/tail-2/assert49
1 files changed, 49 insertions, 0 deletions
diff --git a/tests/tail-2/assert b/tests/tail-2/assert
new file mode 100755
index 000000000..258963dcb
--- /dev/null
+++ b/tests/tail-2/assert
@@ -0,0 +1,49 @@
+#!/bin/sh
+# This test fails with tail from textutils-2.0.
+# It would get something like this:
+# tail: tail.c:718: recheck: Assertion `valid_file_spec (f)' failed.
+# Aborted
+# due to a race condition in which a dev/inode pair is reused.
+
+if test "$VERBOSE" = yes; then
+ set -x
+ tail --version
+fi
+
+tmp=t1-tail.$$
+pwd=`pwd`
+trap "cd $pwd; rm -rf $dir" 0 1 2 3 15
+
+test_failure=0
+mkdir $tmp || test_failure=1
+cd $tmp || test_failure=1
+
+if test $test_failure = 1; then
+ echo 'failure in testing framework'
+ exit 1
+fi
+
+ok='ok ok ok'
+
+touch a foo
+tail --follow=name a foo > err 2>&1 &
+tail_pid=$!
+# Arrange for the tail process to die after 12 seconds.
+(sleep 12; kill $tail_pid) &
+rm -f foo
+echo sleep 7...
+sleep 7
+echo $ok > f
+mv f foo
+
+echo waiting....
+wait
+
+case "`cat err`" in
+ *$ok) fail=0;;
+ *) fail=1;;
+esac
+
+test $fail = 1 && cat err
+
+exit $fail